// Input dialog with history list

#include <fox/fx.h>
#include <fox/fxkeys.h>

#include "HistInputDialog.h"
#include "config.h"
#include "i18n.h"


// Object implementation
FXIMPLEMENT(MyComboBox,FXComboBox,NULL,0)

MyComboBox::MyComboBox(FXComposite *p,FXint cols,FXint nvis,FXObject* tgt,FXSelector sel,FXuint opts):
        FXComboBox(p,cols,nvis,tgt,sel,opts)
{}
FXDEFMAP(HInputDialog) HInputDialogMap[]={
            FXMAPFUNC(SEL_KEYPRESS,0,HInputDialog::onCmdKeyPress),
        };
// Object implementation
FXIMPLEMENT(HInputDialog,DialogBox,HInputDialogMap,ARRAYNUMBER(HInputDialogMap))

// Construct a dialog box
HInputDialog::HInputDialog(FXWindow* w,FXString& inp,FXString message,FXString title,FXString label,FXIcon *ic, int associate):
        DialogBox(w,title,DECOR_TITLE|DECOR_BORDER)
{
    /* Buttons */
    buttons=new FXHorizontalFrame(this,LAYOUT_SIDE_BOTTOM|LAYOUT_FILL_X,0,0,0,0,10,10,5,5);
    /* Cancel */
    new FXButton(buttons,_("&Cancel"),NULL,this,ID_CANCEL,FRAME_RAISED|FRAME_THICK|LAYOUT_RIGHT,0,0,0,0,20,20);
    /* Accept */
    new FXButton(buttons,_("&Accept"),NULL,this,ID_ACCEPT,FRAME_RAISED|FRAME_THICK|LAYOUT_RIGHT,0,0,0,0,20,20);
    if (associate)
    {
        /* Associate */
        new FXCheckButton(buttons,_("A&ssociate"),this,ID_TOGGLE_ASSOCIATE);
    }
    /* Separator */
    new FXHorizontalSeparator(this,LAYOUT_SIDE_BOTTOM|LAYOUT_FILL_X|SEPARATOR_GROOVE);

    FXMatrix *matrix = new FXMatrix(this,2,MATRIX_BY_COLUMNS|LAYOUT_SIDE_TOP|LAYOUT_FILL_X|LAYOUT_FILL_Y);
    // Icon
    new FXLabel(matrix,"",ic,LAYOUT_CENTER_Y|LAYOUT_FILL_COLUMN|LAYOUT_FILL_ROW);
    // Message
    new FXLabel(matrix,message,NULL,JUSTIFY_LEFT|LAYOUT_CENTER_Y|LAYOUT_FILL_COLUMN|LAYOUT_FILL_ROW);

    // Label
    new FXLabel(matrix,label,NULL,LAYOUT_RIGHT|LAYOUT_CENTER_Y|LAYOUT_FILL_COLUMN|LAYOUT_FILL_ROW);
    // Input Field
    input = new MyComboBox(matrix,30,5,NULL,0,COMBOBOX_NO_REPLACE/*COMBOBOX_INSERT_LAST*/|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
    input->setText(inp);
}
void HInputDialog::create()
{
    DialogBox::create();
    //   input->setFocus();
}
void HInputDialog::CursorEnd()
{
    input->Focus();
    //    input->getTextEntry()->setFocus();
    //    input->onFwdToText(this,MKUINT(FXTextField::ID_CURSOR_END,SEL_COMMAND),NULL);
    //    input->onFwdToText(this,MKUINT(0,SEL_FOCUSIN),NULL);
}
void HInputDialog::SelectAll()
{
    input->onFwdToText(this,MKUINT(0,SEL_FOCUSIN),NULL);
    input->onFwdToText(this,MKUINT(FXTextField::ID_SELECT_ALL,SEL_COMMAND),NULL);
    return;
}

long HInputDialog::onCmdKeyPress(FXObject*,FXSelector,void* ptr)
{
    FXEvent* event=(FXEvent*)ptr;
    input->handle(this,MKUINT(message,SEL_KEYPRESS),ptr);
    switch(event->code)
    {
    case KEY_Escape:
        handle(this,MKUINT(ID_CANCEL,SEL_COMMAND),NULL);
        return 1;
    case KEY_KP_Enter:
    case KEY_Return:
        handle(this,MKUINT(ID_ACCEPT,SEL_COMMAND),NULL);
        return 1;
    default:
        return 1;

    }
}

