#ifndef HISTDIALOG_H
#define HISTDIALOG_H

#include "DialogBox.h"

class XComApp;

class MyComboBox : public FXComboBox
{
    FXDECLARE(MyComboBox)
    MyComboBox()
    {
        ;
    }
public:
    FXTextField *getTextEntry()
    {
        return field;
    }
    void Focus()
    {
        field->setFocus();
    }
    MyComboBox(FXComposite *p,FXint cols,FXint nvis,FXObject* tgt=NULL,FXSelector sel=0,FXuint opts=0);
};

class HInputDialog : public DialogBox
{
    FXDECLARE(HInputDialog)
protected:
    FXVerticalFrame* contents;
    FXHorizontalFrame* buttons;
    MyComboBox *input;
    FXLabel*           label;
    FXDataTarget*      string_target;
private:
    HInputDialog()
    {
        ;
    }
public:
    HInputDialog(FXWindow*,FXString& ,FXString,FXString,FXString label="",FXIcon *ic=NULL, int associate=0);
    virtual void create();
    long onCmdKeyPress(FXObject*,FXSelector,void*);
    FXString getText()
    {
        return input->getText();
    }
    void CursorEnd();
    void SelectAll();
    void appendItem(char *str)
    {
        input->appendItem(str);
    };
    FXString getHistoryItem(int pos)
    {
        return input->getItemText(pos);
    }
    int getHistorySize()
    {
        return input->getNumItems();
    }
};
#endif
