#ifndef OPTIONSBOX_H
#define OPTIONSBOX_H

#include <string.h>

// Number of themes
#define THEMES_NUM 10

class FXDialog;
class FXApp;

struct Theme
{
    char *name;
    FXColor color[6];
    Theme()
    {
        name = "";
    };
    Theme(const char *n,FXColor base=0,FXColor bdr=0,FXColor bg=0,FXColor fg=0,FXColor selbg=0,FXColor selfg=0)
    {
        name = strdup(n);
        color[0] = base;
        color[1] = bdr;
        color[2] = bg;
        color[3] = fg;
        color[4] = selbg;
        color[5] = selfg;
    };
    FXbool operator != (const Theme&);
};

class OptionsBox : public FXDialogBox
{
    FXDECLARE(OptionsBox)
private:
    OptionsBox()
    {}
    FXButton   *cwell;
    FXComboBox *colorsBox;
    FXComboBox *themesBox;
    FXList     *themesList;
    FXTextField *iconpath;
    FXTextField *editor;
    FXTextField *viewer;
    FXTextField *xterm;
    FXTextField *cfm;
    FXString    oldiconpath;
    FXString    oldeditor;
    FXString    oldviewer;
    FXString    oldxterm;
    FXString    oldcfm;
    FXCheckButton  *quit;
    FXCheckButton  *del;
    FXCheckButton  *overwrite;
    FXCheckButton  *ask;
    FXCheckButton  *bg;
    FXCheckButton  *root_warn;
    Theme          Themes[THEMES_NUM];
    Theme          currTheme;
public:
    enum{
        ID_ACCEPT=FXDialogBox::ID_LAST,
        ID_BROWSE_EDIT,
        ID_BROWSE_VIEW,
        ID_BROWSE_XTERM,
        ID_BROWSE_CFM,
        ID_COLOR,
        ID_THEME,
        ID_BROWSE_ICON_PATH,
        ID_LAST
    };

public:
    OptionsBox(FXWindow *win);
    long onCmdAccept(FXObject*,FXSelector,void*);
    long onCmdBrowse(FXObject*,FXSelector,void*);
    long onCmdColor (FXObject*,FXSelector,void*);
    long onUpdColor (FXObject*,FXSelector,void*);
    long onCmdTheme (FXObject*,FXSelector,void*);
    long onCmdBrowsePath(FXObject*,FXSelector,void*);
};
#endif
